<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../object/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
</pre><pre class="rust"><code><span class="doccomment">//! # `object`</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The `object` crate provides a unified interface to working with object files</span>
<span class="doccomment">//! across platforms. It supports reading object files and executable files,</span>
<span class="doccomment">//! and writing object files and some executable files.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Raw struct definitions</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Raw structs are defined for: [ELF](elf), [Mach-O](macho), [PE/COFF](pe), [archive].</span>
<span class="doccomment">//! Types and traits for zerocopy support are defined in [pod] and [endian].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Unified read API</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The [read::Object] trait defines the unified interace. This trait is implemented</span>
<span class="doccomment">//! by [read::File], which allows reading any file format, as well as implementations</span>
<span class="doccomment">//! for each file format: [ELF](read::elf::ElfFile), [Mach-O](read::macho::MachOFile),</span>
<span class="doccomment">//! [COFF](read::coff::CoffFile), [PE](read::pe::PeFile), [Wasm](read::wasm::WasmFile).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Low level read API</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In addition to the unified read API, the various `read` modules define helpers that</span>
<span class="doccomment">//! operate on the raw structs. These also provide traits that abstract over the differences</span>
<span class="doccomment">//! between 32-bit and 64-bit versions of the file format.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Unified write API</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [write::Object] allows building a COFF/ELF/Mach-O object and then writing it out.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Low level executable writers</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [write::elf::Writer] and [write::pe::Writer] allow writing executable files.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example for unified read API</span>
<span class="doccomment">//!  ```no_run</span>
<span class="doccomment">//! # #[cfg(feature = &quot;read&quot;)]</span>
<span class="doccomment">//! use object::{Object, ObjectSection};</span>
<span class="doccomment">//! use std::error::Error;</span>
<span class="doccomment">//! use std::fs;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! /// Reads a file and displays the content of the &quot;.boot&quot; section.</span>
<span class="doccomment">//! fn main() -&gt; Result&lt;(), Box&lt;dyn Error&gt;&gt; {</span>
<span class="doccomment">//! # #[cfg(all(feature = &quot;read&quot;, feature = &quot;std&quot;))] {</span>
<span class="doccomment">//!   let bin_data = fs::read(&quot;./multiboot2-binary.elf&quot;)?;</span>
<span class="doccomment">//!   let obj_file = object::File::parse(&amp;*bin_data)?;</span>
<span class="doccomment">//!   if let Some(section) = obj_file.section_by_name(&quot;.boot&quot;) {</span>
<span class="doccomment">//!     println!(&quot;{:#x?}&quot;, section.data()?);</span>
<span class="doccomment">//!   } else {</span>
<span class="doccomment">//!     eprintln!(&quot;section not available&quot;);</span>
<span class="doccomment">//!   }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//!   Ok(())</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! ```</span>

<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_debug_implementations</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="comment">// Style.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::collapsible_if</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::comparison_chain</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::match_like_matches_macro</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::single_match</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::type_complexity</span>)]</span>
<span class="comment">// Occurs due to fallible iteration.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::should_implement_trait</span>)]</span>
<span class="comment">// Unit errors are converted to other types by callers.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::result_unit_err</span>)]</span>
<span class="comment">// Clippy is wrong.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::transmute_ptr_to_ptr</span>)]</span>
<span class="comment">// Worse readability sometimes.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::collapsible_else_if</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;cargo-all&quot;</span>)]</span>
<span class="macro">compile_error!</span>(<span class="string">&quot;&#39;--all-features&#39; is not supported; use &#39;--features all&#39; instead&quot;</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read_core&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;write_core&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span>;

<span class="kw">mod</span> <span class="ident">common</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">common</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">endian</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">endian</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">pod</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">pod</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read_core&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">read</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read_core&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">read</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;write_core&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">write</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;archive&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">archive</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">elf</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">macho</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">pe</span>;
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>